/*
 *$Id: param_types.cpp,v 1.7 2001/09/12 21:32:32 mulix Exp $
 */
#include "param_types.h"

#include <iostream>
#include <assert.h>

ostream& operator<<(ostream& os, const value_type_t& vt)
{
    os<<" value is: ";
    switch(vt.type){
    case(DT_BOOL):os<<"bool: "<<vt.val.b;
	break;
    case(DT_CHAR):os<<"char: "<<vt.val.c;
	break;
    case(DT_INT):os<<"int: "<<vt.val.i;
	break;
    case(DT_SHORT):os<<"short: "<<vt.val.s;
	break;
    case(DT_LONG):os<<"long: "<<vt.val.l;
	break;
    case (DT_FLOAT):os<<"float: "<<vt.val.f;
	break;
    case (DT_STRING):os<<"string: "<<
			 (vt.val.str) ? vt.val.str : "NULL";
	break;
    case (DT_LAST_TYPE):os<<"last value!";
	break;
    default:
	os<<"*** unknown type "<<(int)vt.type<<"***";
	break;
    }
    return os;
}

ostream& operator<<(ostream& os, const operand& op)
{
    switch(op){
    case(OT_EQUAL):
	os<<"equal";
	break;
    case(OT_LESS):
	os<<"less than";
	break;
    case(OT_GREATER):
	os<<"greater than";
	break;
    case(OT_LESS_EQUAL):
	os<<"less or equal than";
	break;
    case(OT_GREATER_EQUAL):
	os<<"greater or equal than";
	break;
    case(OT_NOT_EQUAL):
	os<<"not equal to";
	break;
    case (OT_PATTERN_MATCH) :
	os<<"pattern match";
	break;
    default:
	os<<"\n!! unknown operand '"<<(int)op<<"'!!\n";
    }
    return os;
}

ostream& operator<<(ostream& os, const process_field_t& proc)
{
    switch (proc) {
    case PT_PID: os<<"pid"; break;
    case PT_PPID: os<<"ppid"; break;
    case PT_UID: os<<"uid"; break;
    case PT_EUID: os<<"euid"; break;
    case PT_GID: os<<"gid"; break;
    case PT_EGID: os<<"egid"; break;
    case PT_COMM: os<<"command line"; break;
    case PT_LAST_PROCESS_FIELD: /* fallthrough */
    default:
	assert(false);
	os<<"\n!! unknown process field: "<<int(proc)<<" !!\n";
    }
    return os;
}
