/*
 *$Id: param_types.h,v 1.7 2001/09/14 15:04:27 chooga Exp $
 */
#ifndef _PARAM_TYPES_H_
#define _PARAM_TYPES_H_

using namespace std;

#include <iostream>

#include "sct_rules/rule_engine_public.h"

typedef enum {
    OT_EQUAL = 0,
    OT_LESS,
    OT_GREATER,
    OT_LESS_EQUAL,
    OT_GREATER_EQUAL,
    OT_NOT_EQUAL,
    OT_PLUS,
    OT_MINUS,
    OT_BIT_SHIFT_LEFT,
    OT_BIT_SHIFT_RIGHT,
    OT_BIT_AND,
    OT_BIT_OR,
    OT_BIT_XOR,
    OT_BIT_NOT,
    OT_LOGIC_AND,
    OT_LOGIC_OR,
    OT_LOGIC_NOT,
    OT_PATTERN_MATCH,
    OT_LAST_OPERATOR
} oper_type_t;

typedef oper_type_t operand;

typedef enum {
    PT_PID = 0,
    PT_PPID,
    PT_UID,
    PT_GID, 
    PT_EUID,
    PT_EGID, 
    PT_COMM,
    PT_LAST_PROCESS_FIELD
} process_field_t;

union value_data_t{
    int b;          /* bool   */
    char c;         /* char   */
    int i;          /* int    */
    long l;         /* int    */
    short s;        /* short  */
    float f;        /* float  */
    char* str;      /* string */
};

struct value_type_t {
    data_type_t type;
    value_data_t val;
};

ostream& operator<<(ostream& os, const value_type_t& vt);
ostream& operator<<(ostream& os, const operand& op);
ostream& operator<<(ostream& os, const process_field_t& proc);


#endif

