/*
 *$Id: process_conditional.cpp,v 1.5 2001/09/12 21:32:32 mulix Exp $
 */
#include "process_conditional.h"
#include "validity_checks.h"
#include "token.h"

#include <iostream>

ostream& operator<<(ostream& os, process_conditional& prc)
{
    os<<"processs conditional: "<<endl;
    os<<"\tprocess_field: \n"<<prc._proc_field;
    os<<"\tvalue: "<<prc._val<<endl;
    return os;
}

void process_conditional::set_process_field(const string& str)
{
    if (is_process_field(str)){
	if (str=="PPID"){
	    _proc_field = PT_PPID;
	}else if (str=="PID"){
	    _proc_field = PT_PID;
	}else if (str=="UID"){
	    _proc_field = PT_UID;
	}else if (str=="EID"){
	    _proc_field = PT_EUID;
	}else if (str=="GID"){
	    _proc_field = PT_GID;
	}else if (str=="EGID"){
	    _proc_field = PT_EGID;
	}else if (str=="COMM"){
	    _proc_field = PT_COMM;
	}
    }else{
	_proc_field = PT_LAST_PROCESS_FIELD;
	cerr<<"set_process_field: '"<<str<<"' is not a valid process_field"<<endl;
	throw eUnknownToken();
    }
}

void process_conditional::set_value(const string& val)
{
    if (is_long(val)){
	_val = atol(val.c_str());
    }else{
	cerr<<"proc_conditional::set_value: '"<<val
	    <<"' is not a valid long value"<<endl;
	throw eUnknownToken();
    }
}

bool process_conditional::is_valid()
{
    if (_proc_field == PT_LAST_PROCESS_FIELD){
	return false;
    }
    return true;
}
