/* 
 * $Id: syscalls.cpp,v 1.1 2001/09/11 12:14:41 mulix Exp $
 */ 
/* parse the syscalls.dat file and make it available to the parser
   for validity checks */

#include <iostream>
#include <fstream>

#include "syscalls.h"
#include "validity_checks.h"

syscalls::syscalls_set syscalls::_sys;

syscalls::syscalls()
{
}

syscalls::~syscalls()
{
}

bool
syscalls::load(string file_name)
{
    syscalls::_sys.clear();

    ifstream file(file_name.c_str());

    char buf[2048];
    string::size_type p1 = 0, p2 = 0;
    while (file.getline(buf, sizeof(buf))) {
	if (buf[0] == '#')
	    continue;
	if (!strncmp(buf, "asis", 4))
	    continue;
	if (!strncmp(buf, "include", 7))
	    continue;
       	/* ignore anything we dont know */
	if (strncmp(buf, "sys_", 4))
	    continue;
	/* create a string object, for easier handling */
	string line(buf);
	p2 = line.find(':');
	if (p2 == line.npos)
	    continue;
	p1 = p2 + 2; /* skip whitespace */
	p2 = line.find(':', p1); 
	if (p2 == line.npos)
	    continue;
	string sid = line.substr(p1, p2 - p1);
	if (!is_int(sid))
	    continue;
	int id = atoi(sid.c_str());
	
	p1 = p2 + 2; /* skip ': ' */
	p2 = line.find('(');
	if (p2 == line.npos)
	    continue;
	string name = line.substr(p1, p2 - p1);
	_sys[name] = id;

//	cout<<"syscalls::load(): syscall '"<<name<<"' id '"<<id<<"'"<<endl;
    }
    return (!syscalls::_sys.empty());
}

bool 
syscalls::has_syscall(const string& name)
{
    return (syscalls::_sys.find(name) != _sys.end());
}

int 
syscalls::syscall_id(const string& name)
{
    syscalls_set::const_iterator it = syscalls::_sys.find(name);
    if (it == syscalls::_sys.end())
	return -1;

    return (*it).second;
}
