/*
 *$Id: validity_checks.cpp,v 1.7 2001/09/13 10:46:51 mulix Exp $
 */
using namespace std;

#include <string>
#include <limits.h>

#include <errno.h>

#include "syscalls.h"

extern syscalls syscalls_info;

bool is_int(const string& str)
{
    /* from the strtol man page */
    int res; 
    char* endpt = NULL;
    const char* cstr = str.c_str();
    res = strtol(cstr, &endpt, 10);
    if ((res == LONG_MIN || res == LONG_MAX) && errno == ERANGE)
	return false;

    if (*endpt)
	return false;

    return true;
}

bool is_long(const string& str)
{
    //for the time being
    return is_int(str);
}

bool is_syscall_identifier(const string& str)
{
    return syscalls::has_syscall(str);
}

bool is_value(const string& str)
{
    //is_value needs to know about different value types,
    //how do we pass this information to it?
    return true;
}

bool is_process_field(const string& str){
    if (str=="PPID" ||
	str=="PID"  ||
	str=="UID"  ||
	str=="EID"){
	return true;
    }
    return false;
}

bool is_action(const string& str)
{
    if (str=="LOG" ||
	str=="SUSPEND" ||
	str=="FAIL" ||
	str=="KILL"){
	return true;
    }
    return false;
}

bool is_operand(const string& str){
    if (str=="==" ||
	str=="<" ||
	str==">"  ||
	str=="=<" ||
	str=="=>" ||
	str=="!=" ||
	str=="~="){
	return true;
    }
    return false;
}

bool is_param_type(const string& str)
{
    if (str=="b" ||
	str=="c" ||
	str=="i" ||
	str=="s" ||
	str=="l" ||
	str=="f" || 
	str=="str"){
	return true;
    }
    return false;
}

bool is_condition_matching(const string& str)
{
    if (str=="ANY" || str=="ALL")
	return true;
    return false;
}
