/*
 *$Id: sct_ctrl_lib.h,v 1.6 2001/09/14 15:01:45 chooga Exp $
 */
#ifndef SCT_CTRL_LIB_H_
#define SCT_CTRL_LIB_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "sct_rules/rule_engine_public.h"

typedef struct sct_ctrl_type* sct_ctrl_t;

/* init the library */
sct_ctrl_t
sct_ctrl_init(void);

/* shutdown the library */
int 
sct_ctrl_cleanup(sct_ctrl_t ctrl);

/* add rule */
int 
sct_ctrl_add_rule(sct_ctrl_t ctrl, int rule_id, int syscall_id, 
		  filter_node_t* filter, action_t* act, 
		  int enable_rule);

/* delete a rule */
int
sct_ctrl_del_rule(sct_ctrl_t ctrl, int rule_id, int syscall_id);

/* enable a rule */
int 
sct_ctrl_enable_rule(sct_ctrl_t ctrl, int rule_id, int syscall_id);

/* disable a rule */
int 
sct_ctrl_disable_rule(sct_ctrl_t ctrl, int rule_id, int syscall_id);

/* delete all rules for this syscall */
int 
sct_ctrl_del_all_syscall_rules(sct_ctrl_t ctrl, int syscall_id);

/* delete all rules for ALL syscalls */
int 
sct_ctrl_del_all_rules(sct_ctrl_t ctrl);

/* print the current rules */
int
sct_ctrl_print_all_rules(sct_ctrl_t ctrl);

#ifdef __cplusplus
}
#endif

#endif /* SCT_CTRL_LIB_H_ */
