/*
 *$Id: arch-linux-kernel.h,v 1.1 2001/09/14 14:58:43 chooga Exp $
 */
#ifndef ARCH_LINUX_KERNEL_H_
#define ARCH_LINUX_KERNEL_H_

#ifndef LINUX_KERNEL
#error "arch-linux-kernel.h included and LINUX_KERNEL not defined!"
#endif

/* malloc/free support */
# include <linux/malloc.h>
# include <linux/types.h>
# include <linux/stddef.h>
# include <linux/string.h>
# include <linux/kernel.h>

#define mem_alloc(foo) kmalloc((foo), GFP_KERNEL)
#define mem_free(foo)  kfree((foo))

/* generic print macro */
# define PPRINT(fmt, args...) printk(fmt, ## args)

# ifdef SCT_RULES_DEBUG 

/* values from include/linux/kernel.h */

#undef KERN_NOTICE
#define KERN_NOTICE "<1>"        /* KERN_ALERT */

#undef KERN_INFO 
#define KERN_INFO "<5>"          /* KERN_NOTICE */

#undef KERN_DEBUG
#define KERN_DEBUG "<5>"         /* KERN_NOTICE */

# endif /* SCT_RULES_DEBUG */

#endif /* ARCH_LINUX_KERNEL_H_ */

