/*
 * $Id: syscall_tracker_autogen.c,v 1.1 2001/09/14 15:15:01 chooga Exp $
 */

/* This file is automatically generated - do not edit. */
/* built by './gen_syscalls.pl 256' for Linux. */


#include <asm/errno.h>

/*
 * Tracking functions for syscall hijacking.
 */

/* tracking function for syscall 'open' (5). */
asmlinkage static int
track_syscall_5(const char* pathname, int flags, mode_t mode) {
	typedef int
		(*track_func_5)(const char* pathname, int flags, mode_t mode);
	track_func_5 func = (track_func_5)orig_syscalls[5];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_5_failed_getstring;
	}

	{
		action_t* action = NULL;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* param1 = make_int_val(flags);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[5], 5);
		if (action) {
			tracker_perform_action(rules[5], action, 5, "sil" , kern_pathname, flags, mode);
		}
		up(&tracker_sem);
	}

  tracker_5_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname, flags, mode) : -ENOSYS);
}

/* tracking function for syscall 'link' (9). */
asmlinkage static int
track_syscall_9(const char* oldpath, const char* newpath) {
	typedef int
		(*track_func_9)(const char* oldpath, const char* newpath);
	track_func_9 func = (track_func_9)orig_syscalls[9];
	char* kern_oldpath = NULL;
	char* kern_newpath = NULL;
	long retval;

	retval = getstring(oldpath, &kern_oldpath);
	if (retval < 0) {
		kern_oldpath = NULL;
		goto tracker_9_failed_getstring;
	}
	retval = getstring(newpath, &kern_newpath);
	if (retval < 0) {
		kern_newpath = NULL;
		goto tracker_9_failed_getstring;
	}

	{
		action_t* action = NULL;
		filter_node_t* param0 = make_string_val(kern_oldpath);
		filter_node_t* param1 = make_string_val(kern_newpath);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[9], 9);
		if (action) {
			tracker_perform_action(rules[9], action, 9, "ss" , kern_oldpath, kern_newpath);
		}
		up(&tracker_sem);
	}

  tracker_9_failed_getstring:
	if (kern_oldpath)
		putstring(kern_oldpath);
	if (kern_newpath)
		putstring(kern_newpath);

	if (retval < 0)
		return retval;


	return (func ? (*func)(oldpath, newpath) : -ENOSYS);
}

/* tracking function for syscall 'unlink' (10). */
asmlinkage static int
track_syscall_10(const char* pathname) {
	typedef int
		(*track_func_10)(const char* pathname);
	track_func_10 func = (track_func_10)orig_syscalls[10];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_10_failed_getstring;
	}

	{
		action_t* action = NULL;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[10], 10);
		if (action) {
			tracker_perform_action(rules[10], action, 10, "s" , kern_pathname);
		}
		up(&tracker_sem);
	}

  tracker_10_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname) : -ENOSYS);
}

/* tracking function for syscall 'chdir' (12). */
asmlinkage static int
track_syscall_12(const char* pathname) {
	typedef int
		(*track_func_12)(const char* pathname);
	track_func_12 func = (track_func_12)orig_syscalls[12];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_12_failed_getstring;
	}

	{
		action_t* action = NULL;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[12], 12);
		if (action) {
			tracker_perform_action(rules[12], action, 12, "s" , kern_pathname);
		}
		up(&tracker_sem);
	}

  tracker_12_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname) : -ENOSYS);
}

/* tracking function for syscall 'chmod' (15). */
asmlinkage static int
track_syscall_15(const char* pathname, mode_t mode) {
	typedef int
		(*track_func_15)(const char* pathname, mode_t mode);
	track_func_15 func = (track_func_15)orig_syscalls[15];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_15_failed_getstring;
	}

	{
		action_t* action = NULL;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* param1 = make_long_val(mode);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[15], 15);
		if (action) {
			tracker_perform_action(rules[15], action, 15, "sl" , kern_pathname, mode);
		}
		up(&tracker_sem);
	}

  tracker_15_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname, mode) : -ENOSYS);
}

/* tracking function for syscall 'access' (33). */
asmlinkage static int
track_syscall_33(const char* pathname, int mode) {
	typedef int
		(*track_func_33)(const char* pathname, int mode);
	track_func_33 func = (track_func_33)orig_syscalls[33];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_33_failed_getstring;
	}

	{
		action_t* action = NULL;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* param1 = make_int_val(mode);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[33], 33);
		if (action) {
			tracker_perform_action(rules[33], action, 33, "si" , kern_pathname, mode);
		}
		up(&tracker_sem);
	}

  tracker_33_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname, mode) : -ENOSYS);
}

/* tracking function for syscall 'kill' (37). */
asmlinkage static int
track_syscall_37(pid_t pid, int sig) {
	typedef int
		(*track_func_37)(pid_t pid, int sig);
	track_func_37 func = (track_func_37)orig_syscalls[37];
	long retval;


	{
		action_t* action = NULL;
		filter_node_t* param0 = make_long_val(pid);
		filter_node_t* param1 = make_int_val(sig);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[37], 37);
		if (action) {
			tracker_perform_action(rules[37], action, 37, "li" , pid, sig);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(pid, sig) : -ENOSYS);
}

/* tracking function for syscall 'mkdir' (39). */
asmlinkage static int
track_syscall_39(const char* pathname, mode_t mode) {
	typedef int
		(*track_func_39)(const char* pathname, mode_t mode);
	track_func_39 func = (track_func_39)orig_syscalls[39];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_39_failed_getstring;
	}

	{
		action_t* action = NULL;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* param1 = make_long_val(mode);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[39], 39);
		if (action) {
			tracker_perform_action(rules[39], action, 39, "sl" , kern_pathname, mode);
		}
		up(&tracker_sem);
	}

  tracker_39_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname, mode) : -ENOSYS);
}

/* tracking function for syscall 'rmdir' (40). */
asmlinkage static int
track_syscall_40(const char* pathname) {
	typedef int
		(*track_func_40)(const char* pathname);
	track_func_40 func = (track_func_40)orig_syscalls[40];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_40_failed_getstring;
	}

	{
		action_t* action = NULL;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
			return retval;
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[40], 40);
		if (action) {
			tracker_perform_action(rules[40], action, 40, "s" , kern_pathname);
		}
		up(&tracker_sem);
	}

  tracker_40_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname) : -ENOSYS);
}


/* pointers to stub functions - to be used */
/* when hijacking system calls.            */
func_ptr track_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_5,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_9,
	(func_ptr)track_syscall_10,
	(func_ptr)NULL,
	(func_ptr)track_syscall_12,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_15,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_33,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_37,
	(func_ptr)NULL,
	(func_ptr)track_syscall_39,
	(func_ptr)track_syscall_40,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};
