#ifndef TESTER_H_
#define TESTER_H_

void 
die(const char* fmt, ...);

#define TEST(foo) do { if (!(foo)) die("test '%s' failed\n!", #foo); \
                       else fprintf(stderr, "test '%s' succeeded\n", #foo); \
                     } while (0)

/* module tests */

int 
test_simple_syscall_usage(void);

int 
test_rule_register_deregister(void);

int 
test_all_syscalls_usage(void);

/* sct_rules tests */

int
test_filter_eval_bit(void);

int 
test_eval_complex_filter(void);

int
test_filter_serialize_deserialize(void);

int
test_rules_serialize_deserialize(void);

int 
test_tracking_rule_add_delete(void);

int
test_kernel_variables(void);

int 
test_short_circuiting(void);

#endif /* TESTER_H_ */
